% Example_10_3.m: Find the minima and maxima of
% y = x^3 + 40x^2 - 200x + 12
clc; clear;
% First, plot the function so that we can make some
% useful initial guesses:
x = -40:40;
for i=1:length(x)
    y(i) = x(i)^3 + 40*x(i)^2 - 200*x(i) + 12;
end
plot(x,y);
xlabel('x'),ylabel('y'), grid, title('y vs x');
% Next, find the minimum and maximum using MATLAB's
% anonymous function method (find first guesses by
% eyeballing plot).
[xmin,minvalue] = fminunc(@(x) x^3+40*x^2-200*x+12, 2 );
% Note: To find a maximum, instead find the minimum of
% the negative of the function.
[xmax,maxvalue] = fminunc(@(x) -(x^3+40*x^2-200*x+12),...
    -30 );
% Print results
fprintf('xmin=%.1f minvalue=%.1f, ',xmin,minvalue);
fprintf('xmax=%.1f maxvalue=%.1f\n',xmax,-maxvalue);
