% Example_10_7.m: This program minimizes the material
% surface area of a silo. The silo consists of a right
% cylinder topped by a hemisphere. Solve where the silo
% volume is 8400 m^3.
% Define the vector X = [R,L] where R is radius and L is
% length (as drawn in Figure 10.1)
% The function objfun_silo calculates the silo surface
% area and is the objective function to be minimized.
% The function confun_silo defines the constraint that
% the silo volume be fixed at 8400.
clear; clc;
global V;
V=8400;
% Define bounds: radius and length must be positive.
LB = [0,0];
UB = [];
% Initial guesses for R and L:
Xo = [10.0 20.0];
fprintf('This program minimizes the surface area\n');
fprintf('of a silo consisting of a right cylinder\n');
fprintf('topped by a hemisphere. The silo volume\n');
fprintf('is fixed at %.0f m^3.\n\n',V);
% Run the optimization.  We have no linear constraints,
% so pass [] for those arguments:
[X,fval]=fmincon(@objfun_silo,Xo, ...
    [],[],[],[],LB,UB,@confun_silo);
% Print results:
fprintf('Silo volume:          %9.3f m^3\n',V);
fprintf('Minimum surface area: %9.3f m^2\n',fval);
fprintf('Optimum radius:       %9.3f m\n',X(1));
fprintf('Optimum length:       %9.3f m\n',X(2));
