% Example_2_14.m
% This script calculates functions sin(2x/3) and cos(3x+pi)
% for -pi <= x <= pi. The x domain is subdivided into 50
% subdivisions. The functions at each data point is
% calculated and stored in the vectors 'fsin' and 'fcos'.
% Then the two vectors are printed as a table to a file
% named 'output.txt'. Plots of both functions on the same
% axis are created. Finally, the maximum values of
% 'fsin' and 'fcos' are determined and printed.
clear; clc;
xmin=-pi; dx= 2*pi/50;
for i=1:51
    x(i)=xmin+(i-1)*dx;
    arg1=2*x(i)/3;
    arg2=3*x(i)+pi;
    fsin(i)=sin(arg1);
    fcos(i)=cos(arg2);
end
fo=fopen('output.txt','w');
% Table headings
fprintf(fo,'      x          fsin        fcos \n');
fprintf(fo,'--------------------------------------\n');
for i=1:51
    fprintf(fo,'%10.5f   %10.5f  %10.5f \n', ...
        x(i),fsin(i),fcos(i));
end
fprintf(fo,'--------------------------------------\n\n');
% Print maximum values:
fsin_max=max(abs(fsin));
fcos_max=max(abs(fcos));
fprintf(fo,'fsin_max=%10.5f\n',fsin_max);
fprintf(fo,'fcos_max=%10.5f\n',fcos_max);
% Plot data:
plot(x,fsin,x,fcos,'--');
xlabel('x'), ylabel('fsin,fcos'), grid,
title('fsin and fcos vs. x');
legend('fsin','fcos');
