% Example_2_24.m
% This program uses an anonymous function to linearly
% interpolate the electron mobility of silicon.  Measured
% values of the mobility (cm^2/V-s) vs temperature (K)
% are given [2].
clear; clc;
% Anonymous function (avoids creating an extra .m file):
Muf = @(T,T1,T2,Mu1,Mu2) (Mu1+(T-T1)*(Mu2-Mu1)/(T2-T1));
Tt = [100 150 200 250 300 350 400 450];
Mut = [19650 7427 3723 2180 1407 972.0 705.5 531.8 ];
fprintf('This program interpolates for the electron\n');
fprintf('mobility (Mu) at a specified temperature T.\n');
fprintf('The valid temperature range is 100-450K.\n\n');
T=input('Enter T at which Mu is to be determined: ');
% Determining the closest surrounding temperatures to
% temperature T.
for n=1:length(Tt)-1
    if T >= Tt(n) && T <= Tt(n+1)
        T1=Tt(n); T2=Tt(n+1); Mu1=Mut(n); Mu2=Mut(n+1);
    end
end
Mu=Muf(T,T1,T2,Mu1,Mu2);
fprintf(' T=%.1f (K)   Mu=%.3f (cm^2/V-s) \n',T,Mu);
