% exf2.m
% This script is used with script Example_2_6.m and creates a
% function 'exf2' that evaluates e^x/y. In this
% function, x and y are input variables that need to be
% defined in another program. The output variable in the
% function exf2 is sent back to the calling program.
% This example demonstrates that the names of the
% arguments in the calling program need not be the same
% as those in the function. It is the order list in the
% calling program that needs to be the same as the order
% list in the function.
% In this example, term(n+1) is obtained from term(n) by
% multiplying term(n) by x and dividing by index n. The
% program does its own summing of terms.
% Note: e^x = 1 + x + x^2/2! + x^3/3! + x^4/4! + ...
function exy = exf2(x,y)
% Note: x and y are set equal to w and z respectively.
s=1.0; term=1.0;
for n=1:100
    term=term*x/n;
    s=s+term;
    if abs(term) <= s*1.0e-5
        break;
    end
end
exy=s/y;
% These fprintf statements demonstrate the equivalence
% between function input variables (x,y) and calling
% program variables (w,z) in the program Example_2_6.m.
% Compare the printout of x,y and exy with w,z and q.
fprintf('Values of x,y and exy from exf2():    ');
fprintf('x=%.2f y=%.0f exy=%.5f \n', x, y, exy);
