% linecharge_Ez.m: Function to calculate Ez at (xo,yo,zo)
% for a line charge on the z axis
function Ez = linecharge_Ez(zp)
global xo yo zo lambda epsilon0;
Ez = lambda/(4*pi*epsilon0) * (zo-zp) ...
    ./ (xo.^2 + yo.^2 + (zo-zp).^2).^1.5;
