% Example_6_5.m
% This program solves a system of 3 ordinary differential
% equations by using MATLAB's ode45 function.
% y1'=y2*y3*t, y2'=-y1*y3, y3'=-0.51*y1*y2
% y1(0)=0, y2(0)=1.0, y3(0)=1.0
clear; clc;
initial=[0.0 1.0 1.0];
tspan=0.0:0.1:10.0;
[t,Y]=ode45(@dydt3,tspan,initial);
y1=Y(:,1);
y2=Y(:,2);
y3=Y(:,3);
fid=fopen('output.txt','w');
fprintf(fid,'   t        y1        y2        y3   \n');
fprintf(fid,'-------------------------------------\n');
for i=1:2:101
    fprintf(fid,'%6.2f  %8.4f  %8.4f  %8.4f \n', ...
        t(i),y1(i),y2(i),y3(i));
end
fclose(fid);
plot(t,y1,t,y2,'-.',t,y3,'--');
xlabel('t'), ylabel('y1,y2,y3');
title('(y1, y2, y3) vs. t'), grid;
text(5.2,-0.8,'y1'), text(7.7,-0.25,'y2');
text(4.2,0.85,'y3');
