% Example_8_1.m
% Compute the Fourier series for a pulse train.
T=1e-3;      % pulse period
fo=1/T;      % frequency of pulse train in Hz
tau=0.25e-3; % "on" time of a single pulse
n=1:10;      % we will compute the first 10 coefficients
% compute the DC coefficient:
A0 = tau/T;
% compute coefficients 1 thru n
for i=1:length(n)
    An(i) = (2/(pi *n(i))) * sin(pi*n(i)*fo*tau);
end
% Plot the coefficients:
subplot(2,1,1);
stem([0 fo*n],[A0 An]);
xlabel('Hz'); ylabel('Fourier coefficients');
axis([-200 10200 -.2 .6]);
% Use the Fourier coefficients to reconstitute the pulse
% train over the interval -1.5 < t < 1.5 millisec with n
% coefficients
t=-1.5e-3:1e-6:1.5e-3;
waveform = zeros(1,length(t));
% Add in the DC coefficient
waveform = waveform + A0;
% Add in signal components for 1 thru nth coefficients
for i=1:length(n)
    waveform = waveform + An(i) * cos(2*pi*n(i)*fo*t);
end
subplot(2,1,2);
plot(t*1000,waveform);
xlabel('t (millisec)'); ylabel('reconstituted x(t)');
