% Example_9_2.m
% Fit lab-measured freq response to 1st order response
clear; clc;
% Lab-measured data from Table 9.1:
f =           [ 0  2e3 4e3 6e3 8e3 10e3 ];
V_in =        [ 5    5   5   5   5    5 ];
V_out =       [ 5  2.1 1.3  .8  .6   .5 ];
Phi_degrees = [ 0  -60 -75 -80 -83  -85 ];
% Ratio of V_out to V_in is the magnitude of the
% frequency response:
H_mag = V_out ./ V_in;
% The phase is the measured phase difference (converted
% to radians)
H_phase = Phi_degrees * pi / 180;
% Express the complex freq response H as:
% mag * exp(j*phase)
H = H_mag .* exp(j*H_phase);
% Do polynomial fit to 1/H
A=polyfit(f,1./H,1);
% Compute coefficients of fitted freq response based
% polyfit results
n0 = 2*pi*j/A(1);
d0 = 2*pi*j*A(2)/A(1);
% Print fitted frequency response:
fprintf('Fitted frequency response:\n');
fprintf('    H(f) = %.0f / (j*2*pi*f + %.0f)\n',n0,d0);
fprintf('Pole location: %.0f rad/sec (%.0f Hz)\n',...
    d0, d0/(2*pi));
% For comparison purposes, calculate the fitted curve
% with fine precision. Use 100 log-spaced points from 1Hz
% to 1MHz
f_fine = logspace(0,6,100);
H_fit = n0 ./ (j*2*pi*f_fine + d0);
H_fit_mag = abs(H_fit);
H_fit_phase = angle(H_fit);
% Create Bode plot:
subplot(2,1,1);
loglog(f,H_mag,'o',f_fine,H_fit_mag);
axis([ 1e0 1e6 1e-3 2]);
legend('measured','fitted function');
ylabel('|H(f)|');
title('Fit of measured data to 1st-order freq response');
subplot(2,1,2);
semilogx(f,(180/pi)*H_phase,'o', ...
    f_fine, (180/pi)*H_fit_phase);
axis([ 1e0 1e6 -100 10]);
legend('measured','fitted function');
ylabel('\angleH(f) (degrees)'); xlabel('frequency (Hz)');
